# 148574B Kaito Tokumori
# FFT - IFFT program

import numpy as np
from scipy import fftpack
import pylab as plt
from PIL import Image
import matplotlib.cm as cm

inimg = Image.open('./inimg.png').convert('L')
inimgray = np.asarray(inimg)
plt.subplot(1,3,1)
plt.title('original')
plt.imshow(inimgray, cmap = cm.Greys_r)

fft_img = fftpack.fft2(inimgray, axes=(0,1))
fft_img_arrange = np.log(np.abs(fftpack.fftshift(fft_img)))
max_value = np.max(fft_img_arrange)

plt.subplot(1,3,2)
plt.title('fft')
plt.imshow(fft_img_arrange, cmap = cm.Greys_r)
ifft_img = fftpack.ifft2(fft_img, axes=(0,1)).real
plt.subplot(1,3,3)
plt.title('ifft')
plt.imshow(ifft_img, cmap = cm.Greys_r)
plt.show()
